function Create(self)
	local Effect
	local Offset = self.Vel*(20*TimerMan.DeltaTimeSecs)	-- the effect will be created the next frame so move it one frame backwards towards the barrel
	self.lifeTimer = Timer();
	
    -- trail effects
	for i = 1, 10 do
		Effect = CreateMOSParticle("Tiny Smoke Trail " .. math.random(3), "Coalition.rte")
		if Effect then
			Effect.Vel = self.Vel*(RangeRand(0,0.25));
			Effect.Pos = self.Pos + Vector(0, RangeRand(-1,1)) - Offset
			MovableMan:AddParticle(Effect)	
			Effect.Team = self.Team
			Effect.IgnoresTeamHits = true		
			--print("trail")
		end
	end
	
	for i = 1, 2 do
		Effect = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
		if Effect then
			Effect.Pos = self.Pos - Offset
			Effect.Vel = (self.Vel + Vector(RangeRand(-20,20), RangeRand(-20,20))) / 30
			MovableMan:AddParticle(Effect)
		end
	end
	
	if PosRand() < 0.5 then
		Effect = CreateMOSParticle("Side Thruster Blast Ball 1", "Base.rte")
		if Effect then
			Effect.Pos = self.Pos - Offset
			Effect.Vel = self.Vel / 10
			MovableMan:AddParticle(Effect)
		end
	end
	
	-- muzzle sparks up
	for i = 1, 2 do
		Effect = CreateMOPixel("Spark Yellow 1", "Base.rte")
		if Effect then
			Effect.Vel = self:RotateOffset(Vector(RangeRand(-2,5), RangeRand(3,12)))
			Effect.Pos = self.Pos - Offset
			MovableMan:AddParticle(Effect)			
			--print("sparks up")
		end
	end
	
	-- muzzle sparks down
	for i = 1, 2 do
		Effect = CreateMOPixel("Spark Yellow 1", "Base.rte")
		if Effect then
			Effect.Vel = self:RotateOffset(Vector(RangeRand(-2,5), -RangeRand(3,12)))
			Effect.Pos = self.Pos - Offset
			MovableMan:AddParticle(Effect)
			--print("sparks down")
		end
	end	
end

function Update(self)
	local Effect
	local Offset = self.Vel*(20*TimerMan.DeltaTimeSecs)	-- the effect will be created the next frame so move it one frame backwards towards the barrel
    self.speedThreshold = 40;
	
	if self.HFlipped == false then
					self.flipped = 1;
				else
					self.flipped = -1;
				end
				
	local Effect
	local Offset = self.Vel*(20*TimerMan.DeltaTimeSecs)	-- the effect will be created the next frame so move it one frame backwards towards the barrel
	
	for i = 1, math.floor(self.Vel.Magnitude*0.045) do
		Effect = CreateMOSParticle("Tiny Smoke Trail " .. math.random(3), "Coalition.rte")
		if Effect then
			Effect.Pos = self.Pos - Offset * i/8 + Vector(RangeRand(-2,2),RangeRand(-2,2))
			Effect.Vel = (self.Vel + Vector(RangeRand(-10,30),RangeRand(-10,10))) / 20
			MovableMan:AddParticle(Effect)
		end
	end			
	
	if not self.ToDelete then
        if self.Vel.Magnitude >= self.speedThreshold then
            --Collide with objects and deploy the dissipate effect.
            local pos = Vector();
            local trace = Vector(self.Vel.X, self.Vel.Y) * TimerMan.DeltaTimeSecs * 20;
            if SceneMan:CastObstacleRay(self.Pos, trace, pos, Vector(), 0, self.Team, 0, 5) >= 0 then
                --print("HIT!")	
		
				for i = 1, 5 do		
					Effect = CreateMOPixel("Spark Yellow 1", "Base.rte")
					if Effect then
						Effect.Vel = self:RotateOffset(Vector(RangeRand(-15,0)*self.flipped, RangeRand(-3.14,3.14)))		
						--print("hit glow initialised")
						Effect.Pos = self.Pos + Offset * 0.75			
						MovableMan:AddParticle(Effect)			
						--print("hit glow created")
					end	
					
					Effect = CreateMOSParticle("Tiny Smoke Trail " .. math.random(3), "Coalition.rte")				
					--print("hit sparks 360")
					if Effect then
						Effect.Vel = self:RotateOffset(Vector(RangeRand(-15,0)*self.flipped, RangeRand(-3.14,3.14)))				
						--print("hit sparks velocity set")
						Effect.Pos = self.Pos + Offset * 0.75								
						--print("hit sparks offset set")
						MovableMan:AddParticle(Effect)				
						--print("hit sparks created")
					end
				end		
            end
        end
    end
	
end