function Create(self)
	local Effect
	local Offset = self.Vel*(20*TimerMan.DeltaTimeSecs)	-- the effect will be created the next frame so move it one frame backwards towards the barrel
	self.lifeTimer = Timer();
	
    -- trail effects
	for i = 1, 30 do
		Effect = CreateMOPixel("Laser Trail", "XCo.rte")
		if Effect then
			Effect.Vel = self.Vel*(RangeRand(0,1));
			Effect.Pos = self.Pos + Vector(0, RangeRand(-1,1)) - Offset
			MovableMan:AddParticle(Effect)	
			Effect.Team = self.Team
			Effect.IgnoresTeamHits = true
		end
	end
	
	-- muzzle glow
	Effect = CreateMOPixel("Laser Big Glow", "XCo.rte")
	if Effect then
		Effect.Pos = self.Pos - Offset
		MovableMan:AddParticle(Effect)	
	end
	
	-- muzzle sparks up
	for i = 1, 2 do
		Effect = CreateMOPixel("Laser Spark 2", "XCo.rte")
		if Effect then
			Effect.Vel = self:RotateOffset(Vector(RangeRand(-2,5), RangeRand(3,6)))
			Effect.Pos = self.Pos - Offset
			MovableMan:AddParticle(Effect)	
		end
	end
	
	-- muzzle sparks down
	for i = 1, 2 do
		Effect = CreateMOPixel("Laser Spark 2", "XCo.rte")
		if Effect then
			Effect.Vel = self:RotateOffset(Vector(RangeRand(-2,5), -RangeRand(3,6)))
			Effect.Pos = self.Pos - Offset
			MovableMan:AddParticle(Effect)
		end
	end	
	-- muzzle tiny sparks 360
	for i = 1, 5 do
		Effect = CreateMOPixel("Laser Spark 3", "XCo.rte")
		if Effect then
			Effect.Vel = Vector((math.random()*5)+5,0):RadRotate(math.random()*6.28318);
			Effect.Pos = self.Pos - Offset
			MovableMan:AddParticle(Effect)
		end
	end
end

function Update(self)
	local Effect
	local Offset = self.Vel*(20*TimerMan.DeltaTimeSecs)	-- the effect will be created the next frame so move it one frame backwards towards the barrel
    self.speedThreshold = 120;
	

	if not self.ToDelete then
        if self.Vel.Magnitude >= self.speedThreshold then
            --Collide with objects and deploy the dissipate effect.
            local pos = Vector();
            local trace = Vector(self.Vel.X, self.Vel.Y) * TimerMan.DeltaTimeSecs * 20;
            if SceneMan:CastObstacleRay(self.Pos, trace, pos, Vector(), 0, self.Team, 0, 5) >= 0 then
		
				for i = 1, 3 do		
					Effect = CreateMOPixel("Laser Big Glow", "XCo.rte")
					if Effect then
						Effect.Vel = self.Vel * 0	
						Effect.Pos = self.Pos  + Offset * 0.75			
						MovableMan:AddParticle(Effect)		
					end	
					
					Effect = CreateMOPixel("Laser Spark " ..math.random(3), "XCo.rte")
					if Effect then
						Effect.Vel = self:RotateOffset(Vector(RangeRand(0,25), RangeRand(-3.14,3.14)))
						Effect.Pos = self.Pos   + Offset * 0.75
						MovableMan:AddParticle(Effect)	
					end
				end		
				
				for i = 1, 24 do	
					Effect = CreateMOPixel("Laser Blast", "XCo.rte")
					if Effect then
						Effect.Vel = Vector((math.random()*5)+0,0):RadRotate(math.random()*6.28318);
						Effect.Pos = self.Pos  + Offset * 0.75
						MovableMan:AddParticle(Effect)	
					end
				end		
            end
        end
    end
	
end