function Create(self)
	local Effect
	local Offset = self.Vel*(20*TimerMan.DeltaTimeSecs)	-- the effect will be created the next frame so move it one frame backwards towards the barrel
	self.lifeTimer = Timer();
	
    -- trail effects
	for i = 1, 10 do
		Effect = CreateMOPixel("Light Laser Trail", "XCo.rte")
		if Effect then
			Effect.Vel = self.Vel*(RangeRand(0,1));
			Effect.Pos = self.Pos + Vector(0, RangeRand(-1,1)) - Offset
			MovableMan:AddParticle(Effect)	
			Effect.Team = self.Team
			Effect.IgnoresTeamHits = true		
			--print("trail")
		end
	end
	
	-- muzzle glow
	Effect = CreateMOPixel("Laser Big Glow", "XCo.rte")
	if Effect then
		--Effect.Vel = self.Vel * 0 --self.Vel *(RangeRand(0,0.1)); 
		Effect.Pos = self.Pos - Offset
		MovableMan:AddParticle(Effect)		
		--print("muzzle")
	end
	
	-- muzzle sparks up
	for i = 1, 5 do
		Effect = CreateMOPixel("Laser Spark 2", "XCo.rte")
		if Effect then
			Effect.Vel = self:RotateOffset(Vector(RangeRand(-2,5), RangeRand(3,6)))
			Effect.Pos = self.Pos - Offset
			MovableMan:AddParticle(Effect)			
			--print("sparks up")
		end
	end
	
	-- muzzle sparks down
	for i = 1, 5 do
		Effect = CreateMOPixel("Laser Spark 2", "XCo.rte")
		if Effect then
			Effect.Vel = self:RotateOffset(Vector(RangeRand(-2,5), -RangeRand(3,6)))
			Effect.Pos = self.Pos - Offset
			MovableMan:AddParticle(Effect)
			--print("sparks down")
		end
	end	
	-- muzzle tiny sparks 360
	for i = 1, 5 do
		Effect = CreateMOPixel("Laser Spark 3", "XCo.rte")
		if Effect then
			Effect.Vel = Vector((math.random()*5)+5,0):RadRotate(math.random()*6.28318);
			Effect.Pos = self.Pos - Offset
			MovableMan:AddParticle(Effect)
			--print("sparks 360")
		end
	end
end

function Update(self)
	local Effect
	local Offset = self.Vel*(20*TimerMan.DeltaTimeSecs)	-- the effect will be created the next frame so move it one frame backwards towards the barrel
    self.speedThreshold = 40;
	
	if self.HFlipped == false then
					self.flipped = 1;
				else
					self.flipped = -1;
				end
	
	if not self.ToDelete then
        if self.Vel.Magnitude >= self.speedThreshold then
            --Collide with objects and deploy the dissipate effect.
            local pos = Vector();
            local trace = Vector(self.Vel.X, self.Vel.Y) * TimerMan.DeltaTimeSecs * 20;
            if SceneMan:CastObstacleRay(self.Pos, trace, pos, Vector(), 0, self.Team, 0, 5) >= 0 then
                --print("HIT!")	
		
				for i = 1, 5 do		
					Effect = CreateMOPixel("Laser Big Glow", "XCo.rte")
					if Effect then
						Effect.Vel = self.Vel * 0		
						--print("hit glow initialised")
						Effect.Pos = self.Pos + Offset * 0.75			
						MovableMan:AddParticle(Effect)			
						--print("hit glow created")
					end	
					
					Effect = CreateMOPixel("Laser Spark " ..math.random(1)+1, "XCo.rte")				
					--print("hit sparks 360")
					if Effect then
						Effect.Vel = self:RotateOffset(Vector(RangeRand(-15,0)*self.flipped, RangeRand(-3.14,3.14)))				
						--print("hit sparks velocity set")
						Effect.Pos = self.Pos + Offset * 0.75								
						--print("hit sparks offset set")
						MovableMan:AddParticle(Effect)				
						--print("hit sparks created")
					end
				end		
            end
        end
    end
	
end